/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleCampaignManagerControllerActionReportTypeRequestValue type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleCampaignManagerControllerActionReportTypeRequestValue{}

// GoogleCampaignManagerControllerActionReportTypeRequestValue struct for GoogleCampaignManagerControllerActionReportTypeRequestValue
type GoogleCampaignManagerControllerActionReportTypeRequestValue struct {
	AdProduct *string `json:"adProduct,omitempty"`
}

// NewGoogleCampaignManagerControllerActionReportTypeRequestValue instantiates a new GoogleCampaignManagerControllerActionReportTypeRequestValue object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleCampaignManagerControllerActionReportTypeRequestValue() *GoogleCampaignManagerControllerActionReportTypeRequestValue {
	this := GoogleCampaignManagerControllerActionReportTypeRequestValue{}
	return &this
}

// NewGoogleCampaignManagerControllerActionReportTypeRequestValueWithDefaults instantiates a new GoogleCampaignManagerControllerActionReportTypeRequestValue object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleCampaignManagerControllerActionReportTypeRequestValueWithDefaults() *GoogleCampaignManagerControllerActionReportTypeRequestValue {
	this := GoogleCampaignManagerControllerActionReportTypeRequestValue{}
	return &this
}

// GetAdProduct returns the AdProduct field value if set, zero value otherwise.
func (o *GoogleCampaignManagerControllerActionReportTypeRequestValue) GetAdProduct() string {
	if o == nil || IsNil(o.AdProduct) {
		var ret string
		return ret
	}
	return *o.AdProduct
}

// GetAdProductOk returns a tuple with the AdProduct field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerControllerActionReportTypeRequestValue) GetAdProductOk() (*string, bool) {
	if o == nil || IsNil(o.AdProduct) {
		return nil, false
	}
	return o.AdProduct, true
}

// HasAdProduct returns a boolean if a field has been set.
func (o *GoogleCampaignManagerControllerActionReportTypeRequestValue) HasAdProduct() bool {
	if o != nil && !IsNil(o.AdProduct) {
		return true
	}

	return false
}

// SetAdProduct gets a reference to the given string and assigns it to the AdProduct field.
func (o *GoogleCampaignManagerControllerActionReportTypeRequestValue) SetAdProduct(v string) {
	o.AdProduct = &v
}

func (o GoogleCampaignManagerControllerActionReportTypeRequestValue) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleCampaignManagerControllerActionReportTypeRequestValue) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AdProduct) {
		toSerialize["adProduct"] = o.AdProduct
	}
	return toSerialize, nil
}

type NullableGoogleCampaignManagerControllerActionReportTypeRequestValue struct {
	value *GoogleCampaignManagerControllerActionReportTypeRequestValue
	isSet bool
}

func (v NullableGoogleCampaignManagerControllerActionReportTypeRequestValue) Get() *GoogleCampaignManagerControllerActionReportTypeRequestValue {
	return v.value
}

func (v *NullableGoogleCampaignManagerControllerActionReportTypeRequestValue) Set(val *GoogleCampaignManagerControllerActionReportTypeRequestValue) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleCampaignManagerControllerActionReportTypeRequestValue) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleCampaignManagerControllerActionReportTypeRequestValue) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleCampaignManagerControllerActionReportTypeRequestValue(val *GoogleCampaignManagerControllerActionReportTypeRequestValue) *NullableGoogleCampaignManagerControllerActionReportTypeRequestValue {
	return &NullableGoogleCampaignManagerControllerActionReportTypeRequestValue{value: val, isSet: true}
}

func (v NullableGoogleCampaignManagerControllerActionReportTypeRequestValue) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleCampaignManagerControllerActionReportTypeRequestValue) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
